/*
 * 机具券明细记录
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class PosCouponRecordController : BaseController
    {
        public PosCouponRecordController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 机具券明细记录列表

        /// <summary>
        /// 根据条件查询机具券明细记录列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(PosCouponRecord data, string right, string OrderNo)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.OrderNo = OrderNo;


            return View();
        }

        #endregion

        #region 根据条件查询机具券明细记录列表

        /// <summary>
        /// 机具券明细记录列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(PosCouponRecord data, string PosCouponIdSelect, string FromUserIdMakerCode, string FromUserIdRealName, string ToUserIdMakerCode, string ToUserIdRealName, string ChangeKindSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("OrderNo", "1");



            string condition = " and Status>-1";
            //机具券Id
            if (!string.IsNullOrEmpty(PosCouponIdSelect))
            {
                condition += " and PosCouponId=" + PosCouponIdSelect;
            }
            //来源创客编号
            if (!string.IsNullOrEmpty(FromUserIdMakerCode))
            {
                condition += " and FromUserId in (select FromUserId from UserForMakerCode where MakerCode='" + FromUserIdMakerCode + "')";
            }
            //来源创客真实姓名
            if (!string.IsNullOrEmpty(FromUserIdRealName))
            {
                condition += " and FromUserId in (select FromUserId from UserForRealName where RealName='" + FromUserIdRealName + "')";
            }
            //目标创客编号
            if (!string.IsNullOrEmpty(ToUserIdMakerCode))
            {
                condition += " and ToUserId in (select ToUserId from UserForMakerCode where MakerCode='" + ToUserIdMakerCode + "')";
            }
            //目标创客真实姓名
            if (!string.IsNullOrEmpty(ToUserIdRealName))
            {
                condition += " and ToUserId in (select ToUserId from UserForRealName where RealName='" + ToUserIdRealName + "')";
            }
            //变更类型
            if (!string.IsNullOrEmpty(ChangeKindSelect))
            {
                condition += " and ChangeKind=" + ChangeKindSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("PosCouponRecord", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //机具券Id
                dic["PosCouponId"] = RelationClass.GetPosCouponsInfo(int.Parse(dic["PosCouponId"].ToString()));
                //来源创客
                int FromUserId = int.Parse(function.CheckInt(dic["FromUserId"].ToString()));
                Users fromuserid_Users = db.Users.FirstOrDefault(m => m.Id == FromUserId) ?? new Users();
                dic["FromUserIdMakerCode"] = fromuserid_Users.MakerCode;
                dic["FromUserIdRealName"] = fromuserid_Users.RealName;
                dic.Remove("FromUserId");
                //目标创客
                int ToUserId = int.Parse(function.CheckInt(dic["ToUserId"].ToString()));
                Users touserid_Users = db.Users.FirstOrDefault(m => m.Id == ToUserId) ?? new Users();
                dic["ToUserIdMakerCode"] = touserid_Users.MakerCode;
                dic["ToUserIdRealName"] = touserid_Users.RealName;
                dic.Remove("ToUserId");

            }
            return Json(obj);
        }

        #endregion

        #region 增加机具券明细记录

        /// <summary>
        /// 增加或修改机具券明细记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right, string OrderNo)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.OrderNo = OrderNo;


            return View();
        }

        #endregion

        #region 增加机具券明细记录

        /// <summary>
        /// 增加或修改机具券明细记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(PosCouponRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("OrderNo", data.OrderNo);


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("PosCouponRecord", Fields, 0);
            AddSysLog(data.Id.ToString(), "PosCouponRecord", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改机具券明细记录

        /// <summary>
        /// 增加或修改机具券明细记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, string OrderNo, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.OrderNo = OrderNo;


            PosCouponRecord editData = db.PosCouponRecord.FirstOrDefault(m => m.Id == Id) ?? new PosCouponRecord();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改机具券明细记录

        /// <summary>
        /// 增加或修改机具券明细记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(PosCouponRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("OrderNo", data.OrderNo);


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PosCouponRecord", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "PosCouponRecord", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除机具券明细记录信息

        /// <summary>
        /// 删除机具券明细记录信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "PosCouponRecord", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PosCouponRecord", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "PosCouponRecord", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PosCouponRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "PosCouponRecord", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PosCouponRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("PosCouponRecord", Sort, Id);

            AddSysLog(Id.ToString(), "PosCouponRecord", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.PosCouponRecord.Add(new PosCouponRecord()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "PosCouponRecord", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(PosCouponRecord data, string PosCouponIdSelect, string FromUserIdMakerCode, string FromUserIdRealName, string ToUserIdMakerCode, string ToUserIdRealName, string ChangeKindSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("OrderNo", "1"); //单号


            string condition = " and Status>-1";
            //机具券Id
            if (!string.IsNullOrEmpty(PosCouponIdSelect))
            {
                condition += " and PosCouponId=" + PosCouponIdSelect;
            }
            //来源创客编号
            if (!string.IsNullOrEmpty(FromUserIdMakerCode))
            {
                condition += " and FromUserId in (select FromUserId from UserForMakerCode where MakerCode='" + FromUserIdMakerCode + "')";
            }
            //来源创客真实姓名
            if (!string.IsNullOrEmpty(FromUserIdRealName))
            {
                condition += " and FromUserId in (select FromUserId from UserForRealName where RealName='" + FromUserIdRealName + "')";
            }
            //目标创客编号
            if (!string.IsNullOrEmpty(ToUserIdMakerCode))
            {
                condition += " and ToUserId in (select ToUserId from UserForMakerCode where MakerCode='" + ToUserIdMakerCode + "')";
            }
            //目标创客真实姓名
            if (!string.IsNullOrEmpty(ToUserIdRealName))
            {
                condition += " and ToUserId in (select ToUserId from UserForRealName where RealName='" + ToUserIdRealName + "')";
            }
            //变更类型
            if (!string.IsNullOrEmpty(ChangeKindSelect))
            {
                condition += " and ChangeKind=" + ChangeKindSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("PosCouponRecord", Fields, "Id desc", "0", 1, 20000, condition, "PosCouponId,FromUserId,ToUserId,OrderNo,ChangeKind", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //机具券Id
                dic["PosCouponId"] = RelationClass.GetPosCouponsInfo(int.Parse(dic["PosCouponId"].ToString()));
                //来源创客
                int FromUserId = int.Parse(function.CheckInt(dic["FromUserId"].ToString()));
                Users fromuserid_Users = db.Users.FirstOrDefault(m => m.Id == FromUserId) ?? new Users();
                dic["FromUserIdMakerCode"] = fromuserid_Users.MakerCode;
                dic["FromUserIdRealName"] = fromuserid_Users.RealName;
                dic.Remove("FromUserId");
                //目标创客
                int ToUserId = int.Parse(function.CheckInt(dic["ToUserId"].ToString()));
                Users touserid_Users = db.Users.FirstOrDefault(m => m.Id == ToUserId) ?? new Users();
                dic["ToUserIdMakerCode"] = touserid_Users.MakerCode;
                dic["ToUserIdRealName"] = touserid_Users.RealName;
                dic.Remove("ToUserId");

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("PosCouponId", "机具券Id");
            ReturnFields.Add("FromUserIdMakerCode", "来源创客编号");
            ReturnFields.Add("FromUserIdRealName", "来源创客真实姓名");
            ReturnFields.Add("ToUserIdMakerCode", "目标创客编号");
            ReturnFields.Add("ToUserIdRealName", "目标创客真实姓名");
            ReturnFields.Add("OrderNo", "单号");
            ReturnFields.Add("ChangeKind", "变更类型");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "PosCouponRecord", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
